#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gread.h"


struct file_state_rec *file_states = NULL;

int
state_load(void)
{
	struct file_state_rec *fs, **fsp = &file_states;
	FILE *f;
	char buf[1000];
	char *s;

	f = fopen(STATE_FN, "r");
	if (!f) {
		perror(STATE_FN);
		return -1;
	}

	while (fgets(buf, 1000, f)) {
		buf[strcspn(buf,"\r\n")] = 0;
		fs = safe_malloc(sizeof *fs);
		fs->offset = strtoul(buf, &s, 10);
		if (*s != ':') continue;
		s++;
		fs->total_len = strtoul(s, &s, 10);
		if (*s != ':') continue;
		s++;
		fs->fn = safe_strdup(s);
		fs->next = NULL;
		*fsp = fs;
		fsp = &fs->next;
	}
	
	fclose(f);

	return 0;
}

int
state_save(void)
{
	struct file_state_rec *fs;
	FILE *f;

	f = fopen(STATE_FN,"w");
	if (!f) {
		perror(STATE_FN);
		return -1;
	}

	for (fs = file_states; fs; fs = fs->next) {
		fprintf(f,"%ld:%ld:%s\n", fs->offset, fs->total_len, fs->fn);
	}

	fclose(f); 

	return 0;
}

/* move the specified file to the 'prime position' (head of file_states)
 * because it is the currently open file. */
void
state_prime(char *fn)
{
	struct file_state_rec *f = NULL, **fp;

	/* remove it from where it was */
	for (fp = &file_states; *fp; fp = &(*fp)->next) {
		if (!strcmp((*fp)->fn, fn)) {
			f = *fp;
			*fp = f->next;
			break;
		}
	}

	/* or make it from scratch */
	if (!f) {
		f = safe_malloc(sizeof *f);
		f->fn = safe_strdup(fn);
		f->offset = 0;
		f->total_len = 0;
	}

	f->next = file_states;
	file_states = f;
}
